function [grid, u] = test(n1, n2, p, refinements)
%B = basis(1);
%Q = quadrature(1);

%t = [1 2 1; 1 1 2];

%assemble_stiff(t, B, quadrature(1))
%assemble_mass(t, B, quadrature(2))


disp('create grid');
grid = uniform_grid(n1,n2);

%grid = load('circle');
for i=1:refinements
    grid = refine_grid(grid);
end


n_nodes = size(grid.nodes, 2);
n_edges = size(grid.edges, 2);
if (p==1)
    n = n_nodes;
else
    n = n_nodes+n_edges;
    basisP2 = basis(2);
%    basisP2 = hierarchic_basis(2);
end


if (p==1)
    disp('assemble stiffness matrix');
    A = assemble_P1operator(grid, @assemble_stiff, quadrature(1));

    disp('assemble mass matrix');
    M = assemble_P1operator(grid, @assemble_mass, quadrature(3));
else
    disp('assemble stiffness matrix');
    A = assemble_P2operator(grid, @assemble_stiff, quadrature(3), basisP2);

    disp('assemble mass matrix');
    M = assemble_P2operator(grid, @assemble_mass, quadrature(4), basisP2);
end

disp('assemble right hand side');
if (p==1)
    b = assemble_rhs(grid, @f, quadrature(3), basis(1));
else
    b = assemble_rhs(grid, @f, quadrature(4), basisP2);
end

disp('incorporate boundary values');
AA = A;
for i=1:n_nodes
    if (grid.nodes(3,i))
        AA(i,:) = 0;
        AA(i,i) = 1;
        b(i) = 0;
    end
end
if (p==2)
    for i=1:n_edges
        if (grid.edges(3,i))
            AA(i+n_nodes,:) = 0;
            AA(i+n_nodes,i+n_nodes) = 1;
            b(i+n_nodes) = 0;
        end
    end
end

disp('solve linear system');
u = AA\b;

disp('plot solution');
%trimesh(grid.elements', grid.nodes(1,:)', grid.nodes(2,:)', u, u);
if (p==1)
    plot_P1(grid, u);
end
if (p==2)
    plot_P2(grid, u, basisP2, 1/4);
end
%vtk_trimesh(grid.elements, grid.nodes(1,:)', grid.nodes(2,:)', u, u);
%vtk_trisurf(grid.elements, grid.nodes(1,:)', grid.nodes(2,:)', u, u);



