function plot_P2(grid, u, localBasis, h)

if (nargin<3)
    localBasis = basis(2);
end

if (nargin<4)
    h = 1/4;
end

n_nodes = size(grid.nodes, 2);
n_edges = size(grid.edges, 2);
n_elements = size(grid.elements, 2);



x=0:h:1;
p=[];
for i=1:length(x)
    for j = 1:(length(x)-i+1)
        p(:,end+1) = [x(i); x(j)];
    end
end
[sample_grid] = generate_grid(p, delaunay(p(1,:), p(2,:))');

sample_boundary = sample_grid.edges(1:2, find(sample_grid.edges(3,:)==1));
for i=1:(size(sample_boundary,2)-1)
    [jj, j] = find(sample_boundary(1:2,(i+1):end)== sample_boundary(2,i));
    sample_boundary(1:2,[i+1 i+j]) = sample_boundary(1:2,[i+j i+1]);
    if (jj==2)
        sample_boundary(1:2,i+1) = sample_boundary([2 1],i+1);
    end
end
sample_boundary = [sample_boundary(1,:) sample_boundary(2,end)];


y = zeros(1,size(p,2));

holdstate = ishold();
for t = 1:n_elements
    nodes = grid.elements(1:3,t);
    edges = grid.elements(4:6,t);
    
    indices = [nodes; edges+n_nodes];

    simplex = grid.nodes(1:2, nodes);
    T(:,1) = simplex(:,2) - simplex(:,1);
    T(:,2) = simplex(:,3) - simplex(:,1);

    y(:) = 0;
    for i = (1:localBasis.size)
        for j = 1:size(p,2)
            y(j) = y(j) + localBasis.value(p(1:2,j),i)*u(indices(i));
        end
    end

    pt = T*p;
    pt(1,:) = pt(1,:) + simplex(1,1);
    pt(2,:) = pt(2,:) + simplex(2,1);


    trisurf(sample_grid.elements(1:3,:)', pt(1,:), pt(2,:), y, y);
    hold on;

    line(pt(1,sample_boundary), pt(2,sample_boundary), y(sample_boundary));
end

shading flat;
%shading interp;

if (not(holdstate))
    hold off;
end
